import processing.core.*; 
import processing.data.*; 
import processing.opengl.*; 

import java.awt.event.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class DistortImage extends PApplet {

/**
Wheel mouse taken from http://wiki.processing.org/index.php/Wheel_mouse
@author Rick Companje
*/


//import controlP5.*;


PImage lincoln;
PImage newLincoln;
int scale;
boolean distort, hide, saved;
DraggableBall redballin, greenballin, blueballin, orangeballin, purpleballin,
    redballout, greenballout, blueballout, orangeballout, purpleballout;
PVector center;
//PVector z1,z2,z3,w1,w2,w3;
MoebiusFun moeb;
FixFour frcn;
FixThree fix3;
String imagepath;
boolean locked, pause;
float redxOffset, redyOffset, greenxOffset, greenyOffset, 
    bluexOffset, blueyOffset, orangexOffset, orangeyOffset,
    purplexOffset, purpleyOffset;
int maxsize;
float scaleup = 1.05f;
float scaledown = 1/scaleup;
File lastFile;
String funID = "";

   
public void setup() {
    saved = true;
    pause = true;
    scale = 200;
    maxsize = 1024;
    distort = false;
    hide = false;
    locked = false;
  
    size(maxsize,maxsize);
    newLincoln = new PImage(width, height);
    lincoln = new PImage(0,0);

    center = new PVector(width/2, height/2);
    //frcn = new FourCorners();
    moeb = new MoebiusFun(new PVector(1,0),
			  new PVector(0,0),
			  new PVector(0,0),
			  new PVector(1,0));
    if ( funID == "" ){ funID = "moeb"; }
    /*lincoln = lincoln.get(200,100,width,height);*/

    addMouseWheelListener(new MouseWheelListener() { 
	    public void mouseWheelMoved(MouseWheelEvent mwe) { 
		mouseWheel(mwe.getWheelRotation());
	    }}); 

    initFun();
    openImageFile();  
}

public void openImageFile(){
    pause = true;
    selectInput("Image to load: ","setImage", lastFile);
    while ( pause ){ print(""); }
    if (lincoln.width > lincoln.height){
	lincoln.resize(maxsize,0);
    } else {
	lincoln.resize(0,maxsize);
    }
    centerLincoln();
    //println("Centered");
    rewrite();
    //println("Rewritten");
}


public void centerLincoln(){
    PVector del;
    if ( lincoln.width < maxsize ){
	del = new PVector( ( maxsize - lincoln.width ) / 2, 0 );
    } else {
	del = new PVector( 0, ( maxsize - lincoln.height ) / 2 );
    }
    redballout.bpos.add( del );
    blueballout.bpos.add( del );
    greenballout.bpos.add( del );
    rewriteMoeb();
    fixDistortion();
}

public void initFun(){
    background(0);
    redballout = new DraggableBall( 5, color(128, 0,0));
    redballin = new DraggableBall( 5, color(128, 0,0));
    redballin.bpos = new PVector(center.x,center.y);
    redballout.bpos = new PVector(center.x,center.y);
    orangeballout  = new DraggableBall( 5, color(192, 128, 0));
    orangeballin = new DraggableBall( 5, color(192, 128, 0));
    orangeballin.bpos = new PVector( 1.5f*center.x, 0.5f*center.y);
    orangeballout.bpos = new PVector( 1.5f*center.x, 0.5f*center.y);
    greenballout = new DraggableBall( 5, color(0,128,0));
    greenballin = new DraggableBall( 5, color(0,128,0));
    greenballin.bpos = new PVector(center.x/2,center.y/2);
    greenballout.bpos = new PVector(center.x/2,center.y/2);
    blueballout = new DraggableBall( 5, color(0,0,128));
    blueballin = new DraggableBall( 5, color(0,0,128));
    blueballin.bpos = new PVector(3*center.x/2,3*center.y/2);
    blueballout.bpos = new PVector(3*center.x/2,3*center.y/2);
    purpleballout = new DraggableBall( 5, color(128,0,128));
    purpleballin = new DraggableBall( 5, color(128,0,128));
    purpleballin.bpos = new PVector( 0.5f*center.x, 1.5f*center.y );
    purpleballout.bpos = new PVector( 0.5f*center.x, 1.5f*center.y );
}

public void setImage(File fid){
  if ( fid != null ){
      //lincoln = new PImage();
      lincoln.resize(0,0);
      lincoln = loadImage(fid.getAbsolutePath()); 
      lastFile = fid;
      hide = false;
      locked = false;
  }
  pause = false;
}

public void saveImage(){
  selectOutput("Select file to save to: ","imageSaver",lastFile);
}

public void imageSaver(File fid){
  if ( fid != null ){
    newLincoln.save(fid.getAbsolutePath());
   lastFile = fid;
   saved = true;
  }
}


public void rewrite(){
    if ( funID == "moeb" ){
	rewriteMoeb();
    } else if ( funID == "frcn" ){
	rewriteFixFour();
    } else {
	rewriteFixThree();
    }
    saved = false;
}
  
public void rewriteMoeb() {
    moeb.calcCons( redballout.bpos,greenballout.bpos,blueballout.bpos,
		   redballin.bpos,greenballin.bpos,blueballin.bpos);
    //println("center = " + center);
    //println("mfun(center) = " + mfun.out(center));
    //println();
    //newLincoln = new PImage(width, height);
    for ( int x = 0; x < newLincoln.width; x++ ) {
	for ( int y = 0; y < newLincoln.height; y++ ) {
	    PVector z = new PVector(x,y);
	    PVector w = moeb.out(z);
	    int c = interpolate(lincoln, w);
	    newLincoln.set(x, y, c);
	}
    }
    /*newLincoln.resize(width,height);*/
    //image(newLincoln,0,0);
}
public void rewriteFixFour() {
    frcn = new FixFour( greenballin.bpos, orangeballin.bpos,
			blueballin.bpos, purpleballin.bpos,
			redballout.bpos, redballin.bpos);
    //newLincoln = new PImage(width, height);
    for ( int x = 0; x < newLincoln.width; x++ ) {
	for ( int y = 0; y < newLincoln.height; y++ ) {
	    // PVector z = new PVector(x + redballout.bpos.x,
	    // 			    y + redballout.bpos.y);
	    PVector z = new PVector(x,y);
	    PVector w = frcn.out(z);
	    int c = interpolate(lincoln, w);
	    newLincoln.set(x, y, c);
	}
    }
    /*newLincoln.resize(width,height);*/
    //image(newLincoln,0,0);
}

public void rewriteFixThree() {
    fix3 = new FixThree( greenballin.bpos, blueballin.bpos, 
			 purpleballin.bpos,
			 orangeballout.bpos, orangeballin.bpos,
			 redballout.bpos, redballin.bpos);
    // println("P(0) = " + frcn.out(center));
    // println(" frcn a0 = " + frcn.zeroPoly.a[0]);
    // println(" frcn a1 = " + frcn.zeroPoly.a[1]);
    // println(" frcn a2 = " + frcn.zeroPoly.a[2]);
    // println(" frcn a3 = " + frcn.zeroPoly.a[3]);
    // println(" frcn a4 = " + frcn.zeroPoly.a[4]);
    // println(" red = " + redballin.bpos );
    // println(" P(red) = " + frcn.zeroPoly.out( redballin.bpos ));
    // println(" green = " + greenballin.bpos );
    // println(" P(green) = " + frcn.zeroPoly.out( greenballin.bpos ));
    // println(" frcn(green) = " + frcn.out( greenballin.bpos ));
    // println();
    //newLincoln = new PImage(width, height);
    for ( int x = 0; x < newLincoln.width; x++ ) {
	for ( int y = 0; y < newLincoln.height; y++ ) {
	    PVector z = new PVector(x,y);
	    PVector w = fix3.out(z);
	    int c = interpolate(lincoln, w);
	    newLincoln.set(x, y, c);
	}
    }
    //image(newLincoln,0,0);
}




public PVector toCenter( PVector z){
    PVector w0 = cAdd( z, cNeg(center));
    w0.div(scale);
    return( w0 );
}
public PVector fromCenter( PVector z){
    PVector w0 = new PVector();
    w0.mult( z, scale, w0);
    return( cAdd( w0, center) );
}



public void draw() {
    background(0);
    if ( distort ){
	image(newLincoln,0,0);
	if ( !hide){
	    redballout.draw();
	    greenballout.draw();
	    blueballout.draw();
	    if ( funID == "frcn" || funID == "fix3" ){
		orangeballout.draw();
		purpleballout.draw();
	    } 
	}
    } else {
	image(lincoln,0,0);
	if ( !hide ){
	    redballin.draw();
	    greenballin.draw();
	    blueballin.draw();
	    if (funID == "frcn" || funID == "fix3" ){
		orangeballin.draw();
		purpleballin.draw();
	    }
	}
    }
    if ( !hide ){
	fill(255);
	text( funID, width - 40, height - 10);
	if ( distort ){
	    if ( saved ){
		text( " distorted ", 10, height - 10);
	    } else {
		text( "*distorted*", 10, height - 10);
	    }
	}
    }
}

public void mousePressed() {
    /*distort = !distort;*/
    if ( !hide ){
	if ( distort ){
	    if ( funID == "moeb" ){
		if( !redballout.mousePressed() && 
		    !greenballout.mousePressed() &&
		    !blueballout.mousePressed() ){
		    mousePressedBG();
		}
	    } else {
		if( !redballout.mousePressed() ){
		    if ( funID == "fix3" &&
			 !orangeballout.mousePressed() ){
			mousePressedBG();
		    }
		}
	    }
	} else {
	    if ( !redballin.mousePressed() &&
		 !greenballin.mousePressed() &&
		 !blueballin.mousePressed() &&
		 !orangeballin.mousePressed() &&
		 !purpleballin.mousePressed()){
		mousePressedBG();
	    }
	}
    }
}

public void mouseDragged() {
  if ( !hide ){
  if ( distort ){
  redballout.mouseDragged();
  greenballout.mouseDragged();
  blueballout.mouseDragged();
  orangeballout.mouseDragged();
  purpleballout.mouseDragged();
  } else {
  redballin.mouseDragged();
  greenballin.mouseDragged();
  blueballin.mouseDragged();
  orangeballin.mouseDragged();
  purpleballin.mouseDragged();
  }
  }
  mouseDraggedBG();
}

public void mouseReleased() {
    if ( !hide ){
	if ( distort ){
	    redballout.mouseReleased();
	    greenballout.mouseReleased();
	    blueballout.mouseReleased();
	    orangeballout.mouseReleased();
	    purpleballout.mouseReleased();

	    if ( funID == "frcn" ){
		greenballin.bpos = new PVector(greenballout.bpos.x,greenballout.bpos.y);
		blueballin.bpos = new PVector(blueballout.bpos.x,blueballout.bpos.y);
		orangeballin.bpos = new PVector(orangeballout.bpos.x,orangeballout.bpos.y);
		purpleballin.bpos = new PVector(purpleballout.bpos.x,purpleballout.bpos.y);
	    } else if ( funID == "fix3" ){
		greenballin.bpos = new PVector(greenballout.bpos.x,greenballout.bpos.y);
		blueballin.bpos = new PVector(blueballout.bpos.x,blueballout.bpos.y);
		purpleballin.bpos = new PVector(purpleballout.bpos.x,purpleballout.bpos.y);
	    }

	    rewrite();
	} else {
	    redballin.mouseReleased();
	    greenballin.mouseReleased();
	    blueballin.mouseReleased();
	    orangeballin.mouseReleased();
	    purpleballin.mouseReleased();
  
	    redballout.bpos = new PVector(redballin.bpos.x,redballin.bpos.y);
	    greenballout.bpos  = new PVector(greenballin.bpos.x,greenballin.bpos.y);
	    blueballout.bpos   = new PVector(blueballin.bpos.x,blueballin.bpos.y);
	    orangeballout.bpos = new PVector(orangeballin.bpos.x,orangeballin.bpos.y);
	    purpleballout.bpos = new PVector(purpleballin.bpos.x,purpleballin.bpos.y);
  
	    rewrite();
	}
    }
    mouseReleasedBG();
}

public void keyPressed(){
    if ( key == ' ' ){
        distort = !distort;
    } else if ( key == 'h' ){
      hide = !hide;
    } else if ( key == 'f' ){
       fixDistortion(); 
    } else if ( key == 'q' ){
      exit();
    } else if ( key == 'o' ){
      initFun();
      openImageFile(); 
    } else if ( key == 's' ){
      saveImage(); 
    } else if ( key == 'c' ){
      toggleFun(); 
    }
}

public void toggleFun(){
    if ( funID == "moeb" ){
	funID = "frcn";
    } else if ( funID == "frcn" ){
	funID = "fix3";
    } else if ( funID == "fix3" ){
	funID = "moeb";
    } 
    initFun();
    distort = false;
    rewrite();
}

public void fixDistortion(){
    //println("Fixing distortion");
    lincoln.resize(width,height);
    lincoln.copy(newLincoln,0,0,width,height,0,0,width,height);
    redballin.bpos = new PVector(center.x,center.y);
    redballout.bpos = new PVector(center.x,center.y);
    greenballin.bpos = new PVector(center.x/2,center.y/2);
    greenballout.bpos = new PVector(center.x/2,center.y/2);
    blueballin.bpos = new PVector(3*center.x/2,3*center.y/2);
    blueballout.bpos = new PVector(3*center.x/2,3*center.y/2);
    orangeballin.bpos = new PVector( 1.5f*center.x, 0.5f*center.y);
    orangeballout.bpos = new PVector( 1.5f*center.x, 0.5f*center.y);
    purpleballin.bpos = new PVector( 0.5f*center.x, 1.5f*center.y );
    purpleballout.bpos = new PVector( 0.5f*center.x, 1.5f*center.y );
    rewrite();
    distort = false;
}



public void mousePressedBG() {
      locked = true; 
    redxOffset = mouseX-redballout.bpos.x; 
    redyOffset = mouseY-redballout.bpos.y;
    greenxOffset = mouseX-greenballout.bpos.x; 
    greenyOffset = mouseY-greenballout.bpos.y;
    bluexOffset = mouseX-blueballout.bpos.x; 
    blueyOffset = mouseY-blueballout.bpos.y;
    orangexOffset = mouseX-orangeballout.bpos.x; 
    orangeyOffset = mouseY-orangeballout.bpos.y;
    purplexOffset = mouseX-purpleballout.bpos.x; 
    purpleyOffset = mouseY-purpleballout.bpos.y;
  }

  public void mouseDraggedBG() {
    if ( locked && distort ) {
      redballout.bpos.x = mouseX-redxOffset; 
      redballout.bpos.y = mouseY-redyOffset;
      greenballout.bpos.x = mouseX-greenxOffset; 
      greenballout.bpos.y = mouseY-greenyOffset;
      blueballout.bpos.x = mouseX-bluexOffset; 
      blueballout.bpos.y = mouseY-blueyOffset;
      orangeballout.bpos.x = mouseX-orangexOffset; 
      orangeballout.bpos.y = mouseY-orangeyOffset;
      purpleballout.bpos.x = mouseX-purplexOffset; 
      purpleballout.bpos.y = mouseY-purpleyOffset;
    }}

public void mouseReleasedBG() {
    locked = false;
  }
  
public void mouseWheel(int delta) {
    // if ( funID == "frcn" ){
    // 	return;
    // }
    if ( !distort ){
	return;
    }
    float rat;
    if ( delta < 0 ){
	rat = scaleup;
    } else {
	rat = scaledown;
    }
    redballout.bpos.mult(rat);
    greenballout.bpos.mult(rat);
    blueballout.bpos.mult(rat);
    if ( funID == "frcn" ){
	orangeballout.bpos.mult(rat);
	purpleballout.bpos.mult(rat);
	greenballin.bpos.mult(rat);
	blueballin.bpos.mult(rat);
	orangeballin.bpos.mult(rat);
	purpleballin.bpos.mult(rat);
    } else if ( funID == "fix3" ){
	orangeballout.bpos.mult(rat);
	purpleballout.bpos.mult(rat);
	greenballin.bpos.mult(rat);
	blueballin.bpos.mult(rat);
	purpleballin.bpos.mult(rat);
    }
    rewrite();
}
 

public PVector cMult ( PVector v1, PVector v2){
    PVector v1c = cConj(v1);
    float x = v1c.dot(v2);
    float y = v1c.cross(v2).z;
    return(new PVector(x,y));
}

public PVector cConj (PVector v){
    return(new PVector(v.x,-v.y));
}

public PVector cInverse( PVector z ){
   float m = z.mag();
   PVector res = cConj(z);
   res.div(m*m);
   return(res);
}

public PVector cAdd( PVector z1, PVector z2){
 PVector res = new PVector(z1.x,z1.y);
 res.add(z2);
  return(res); 
}

public PVector cNeg (PVector v){
    return(new PVector(-v.x,-v.y));
}

public PVector funMult(PVector z){
  PVector z1 = cMult(z,redballout.bpos);
  z1.div(scale);
   return(z1);
}

public PVector funCropCorner(PVector z){
  PVector w = new PVector(redballout.bpos.x,redballout.bpos.y);
  w.sub(redballin.bpos);
  w.add(z);
   return(w);
}

class FourCorners{
PVector b, one, rea2, ma4, bma4, nose; 

FourCorners(){
	PVector a = toCenter( new PVector( width, height ));
	PVector a2 = cMult( a, a);
	rea2 = new PVector(-2 * a2.x, 0);
	ma4 = new PVector(a2.x*a2.x + a2.y*a2.y, 0);
	b = new PVector(1,0);
	bma4 = cMult( b, ma4);
	one = new PVector(1,0);
	nose = new PVector(0,0);
}

public PVector out(PVector z){
	PVector w0 = toCenter( z );
	PVector w1 = subout(w0);	
	PVector w2 = fromCenter( w1 );
	return( w2 );
}

public PVector subout(PVector z){
	PVector w0 = cAdd( z, nose);
	PVector w1 = cAdd( cMult( w0, w0), rea2 );
	PVector w2 = cAdd( cMult( w1, cMult( b, w0)), one);
	PVector w3 = cAdd( cMult( w2, w0 ), bma4);
	return( w3 );
}

public void calcCons( PVector w ){
     PVector z = toCenter(w);
     nose = z;
     //println( "z = " + z );
     b = new PVector(1,0);
     //println( "b = " + b );
     bma4 = ma4;
     PVector pz = subout(z);
     //println( "pz = " + pz );
     pz = cAdd( pz, cNeg(z));
     //println( "ma4 = " + ma4 );
     //println( "pz = " + pz );
     //println( "1/pz = " + cInverse(pz) );
     b = cMult( cNeg(z), cInverse( pz ));
     bma4 = cMult( b, ma4);
     //println( "b = " + b );
}
}

class MoebiusFun{
      PVector a, b, c, d;

MoebiusFun( PVector va,PVector vb,PVector vc,PVector vd){
	    a = va;
	    b = vb;   
	    c = vc;
	    d = vd;
}

public PVector out( PVector z){
	PVector num = cAdd( cMult(a,z), b);
	PVector den = cAdd( cMult(c,z), d);

	PVector res = cMult( num, cInverse(den) );
	return( res );
} 

public void calcCons(  PVector in1, PVector in2, PVector in3, 
PVector out1, PVector out2, PVector out3){

MoebiusFun rat = new MoebiusFun(cAdd(out1,cNeg(out3)),
cMult(in2,cAdd(cNeg(out1),out3)),
cAdd(out2,cNeg(out3)),
cMult(in1,cAdd(cNeg(out2),out3)));
PVector r = rat.out(in3);
/*println("r = " + r);
println("a = " + rat.a);
println("b = " + rat.b);
println("c = " + rat.c);
println("d = " + rat.d);
println("in1 = " + in1);
println("out1 = " + out1);
println("in2 = " + in2);
println("out2 = " + out2);
println("in3 = " + in3);
println("out3 = " + out3);*/
a = cAdd( out1, cMult(cNeg(r),out2));
b = cAdd( cMult( r, cMult( in1, out2)), cNeg( cMult( in2, out1)));
c = cAdd(new PVector(1,0),cNeg(r));
d = cAdd( cMult( r, in1), cNeg(in2));
}
}


// class Poly4{
//     PVector[] a;

//     Poly4(){
// 	a = new PVector[5];
// 	for ( int i = 0; i < 5; i = i + 1 ){
// 	    a[i] = new PVector(0,0);
// 	}
//     }
//     Poly4( PVector[] cons){
// 	a = new PVector[5];
// 	for ( int i = 0; i < 5; i = i + 1 ){
// 	    a[i] = cons[i];
// 	}
//     }
//     PVector out( PVector z ){
// 	PVector result = new PVector(a[4].x,a[4].y);
// 	for ( int i = 3; i >= 0; i = i - 1 ){
// 	    result = cAdd( cMult( result, z ), a[i] );
// 	}
// 	return(result);
//     }
//     void calcConsFromZeros( PVector[] zeros){
// 	a[0] = cMult( cMult( zeros[0], zeros[1]), cMult( zeros[2], zeros[3]));
// 	a[1] = cNeg( cAdd( cAdd ( cMult( cMult( zeros[0], zeros[1]), zeros[2]),
// 				  cMult( cMult( zeros[0], zeros[1]), zeros[3])),
// 			   cAdd ( cMult( cMult( zeros[0], zeros[2]), zeros[3]),
// 				  cMult( cMult( zeros[1], zeros[2]), zeros[3]))));
// 	a[2] = cAdd( cAdd( cAdd( cMult( zeros[0], zeros[1]),
// 				 cMult( zeros[0], zeros[2])),
// 			   cAdd( cMult( zeros[0], zeros[3]),
// 				 cMult( zeros[1], zeros[2]))),
// 		     cAdd( cMult( zeros[1], zeros[3]),
// 			   cMult( zeros[2], zeros[3])));
// 	a[3] = cNeg( cAdd( cAdd( zeros[0], zeros[1]), 
// 			   cAdd( zeros[2], zeros[3])));
// 	a[4] = new PVector(1,0);			    
//     }
// }

class Polynomial{
    int degree;
    PVector[] a;

    Polynomial( int d ){
	degree = d;
	a = new PVector[d+1];
	for ( int i = 0; i <= d; i = i + 1 ){
	    a[i] = new PVector(0,0);
	}
    }
    Polynomial( int d, PVector[] cons ){
	degree = d;
	a = new PVector[d+1];
	for ( int i = 0; i <= d; i = i + 1 ){
	    a[i] = cons[i];
	}
    }
    public PVector out( PVector z ){
	PVector result = new PVector(a[degree].x,a[degree].y);
	for ( int i = degree-1; i >= 0; i = i - 1 ){
	    result = cAdd( cMult( result, z ), a[i] );
	}
	return(result);
    }
    public void calcConsFromZeros( PVector[] zeros){
	PVector[] coeffs = new PVector[ degree+1 ];
	coeffs[0] = new PVector(1,0);
	for ( int i = 1; i <= degree; i = i + 1 ){
	    coeffs[i] = new PVector(0,0);
	}
	a = calcCoeffsFromZeros( zeros, coeffs, 0);
    }
    public PVector[] calcCoeffsFromZeros( PVector[] zeros, PVector[] coeffs, int n ){
	if ( n == zeros.length ){
	    return( coeffs );
	}
	PVector[] newcoeffs = new PVector[ zeros.length + 1 ];
	for ( int i = 0; i <= zeros.length; i = i + 1 ){
	    newcoeffs[i] = cMult( coeffs[i], cNeg( zeros[n] ));
	}
	for ( int i = 1; i <= zeros.length; i = i + 1 ){
	    newcoeffs[i] = cAdd( newcoeffs[i], coeffs[i-1] );
	}
	return( calcCoeffsFromZeros( zeros, newcoeffs, n+1 ));
    }
}




class FixFour{
    PVector b; 
    Polynomial zeroPoly;

    FixFour( PVector c1, PVector c2, PVector c3, PVector c4, 
		 PVector nosein,  PVector noseout){
	zeroPoly = new Polynomial( 4 );
	PVector origin = new PVector(0,0);
	PVector[] zeros = new PVector[4];
	zeros[0] = c1;
	zeros[1] = c2;
	zeros[2] = c3;
	zeros[3] = c4;
	zeroPoly.calcConsFromZeros( zeros );
	PVector pz0 = zeroPoly.out( nosein );
	if ( pz0 != origin ){
	    b = cMult( cAdd( noseout, cNeg( nosein )), cInverse( pz0 ));
	} else {
	    b = origin;
	}
    }

    public PVector out(PVector z){
	return( cAdd( cMult( b, zeroPoly.out(z)), z));
    }
}

class FixThree{
    Polynomial zeroPoly, denom;

    FixThree( PVector c1, PVector c2, PVector c3, 
	      PVector inf1,  PVector inf2 ){
	zeroPoly = new Polynomial( 3 );
	PVector[] zeros = new PVector[3];
	zeros[0] = c1;
	zeros[1] = c2;
	zeros[2] = c3;
	zeroPoly.calcConsFromZeros( zeros );
	
	denom = new Polynomial( 2 );
	zeros = new PVector[2];
	zeros[0] = inf1;
	zeros[1] = inf2;
	denom.calcConsFromZeros( zeros );
    }
    FixThree( PVector c1, PVector c2, PVector c3, 
	      PVector in1,  PVector out1,
	      PVector in2, PVector out2 ){
	if ( in1.x == out1.x && in1.y == out1.y ){
	    if ( in2.x != out2.x || in2.y != out2.y ){
		//println("4 fixed points");
		zeroPoly = new Polynomial( 4 );
		PVector[] zeros = new PVector[4];
		zeros[0] = c1;
		zeros[1] = c2;
		zeros[2] = c3;
		zeros[3] = in1;
		zeroPoly.calcConsFromZeros( zeros );
	
		PVector[] conslist = new PVector[1];
	    
		conslist[0] = cMult( cNeg( zeroPoly.out(in2)),
				     cInverse( cAdd( out2, 
						     cNeg( in2))));
		denom = new Polynomial( 0, conslist);
		return;
	    } else {
		//println("5 fixed points");
		PVector[] conslist = new PVector[1];
		conslist[0] = new PVector(0,0);
		zeroPoly = new Polynomial( 0, conslist );
		conslist[0] = new PVector(1,0);
		denom = new Polynomial( 0, conslist );
		return;
	    }
	} else {
	    //println("3 fixed points");
	    zeroPoly = new Polynomial( 3 );
	    PVector[] zeros = new PVector[3];
	    zeros[0] = c1;
	    zeros[1] = c2;
	    zeros[2] = c3;
	    zeroPoly.calcConsFromZeros( zeros );

	    PVector[] conslist = new PVector[3];
	    PVector f1 = cMult( cNeg( zeroPoly.out(in1)),
				cInverse( cAdd( out1, cNeg( in1))));
	    PVector f2 = cMult( cNeg( zeroPoly.out(in2)),
				cInverse( cAdd( out2, cNeg( in2))));
	    PVector zsq1 = cMult( in1, in1);
	    PVector zsq2 = cMult( in2, in2);
	    conslist[2] = new PVector(-1,0);
	    conslist[1] = cMult( cAdd( cAdd( f1, cNeg(f2)),
				       cAdd( zsq1, cNeg(zsq2))),
				 cInverse( cAdd( in1, cNeg( in2))));
	    conslist[0] = cAdd( f1, cAdd( zsq1, 
					  cNeg( cMult( conslist[1], in1))));
	    denom = new Polynomial( 2, conslist);
	    return;
	}
    }

    public PVector out(PVector z){
	PVector denVal =  denom.out(z);
	return( cMult( cAdd( cNeg( zeroPoly.out(z) ), 
			     cMult( z, denVal)),
		       cInverse( denVal )));
    }

}

class DraggableBall {

  PVector bpos;
  int ballRadius;
  boolean overBall;
  boolean locked;
  float xOffset; 
  float yOffset; 
  int fillColor;
  int baseColor;
  int edgeColor;

  DraggableBall( int r, int c ) {
    ballRadius = r;
    overBall = false;
    locked = false;
    xOffset = 0.0f; 
    yOffset = 0.0f; 
    fillColor = c;
    baseColor = c;
    edgeColor = c;
    bpos = new PVector(0, 0, 0);
  }





  public void draw() {

    PVector mouseV = new PVector(mouseX, mouseY);
    if ( mouseV.dist(bpos) < ballRadius ) {
      overBall = true;  
      if (!locked) { 
        edgeColor = color(255); 
        fillColor = baseColor;
      }
    } 
    else {
      edgeColor = baseColor;
      fillColor = baseColor;
      overBall = false;
    }

    ellipseMode(RADIUS);  
    fill(fillColor);
    stroke(edgeColor);
    ellipse(bpos.x, bpos.y, ballRadius, ballRadius);
  }

  public boolean mousePressed() {
    if (overBall) { 
      locked = true; 
      fillColor = lerpColor(baseColor, color(255), 0.5f);
    xOffset = mouseX-bpos.x; 
    yOffset = mouseY-bpos.y;
      return(true);
    } 
    else {
      locked = false;
      return(false);
    }
  }

  public void mouseDragged() {
    if (locked) {
      bpos.x = mouseX-xOffset; 
      bpos.y = mouseY-yOffset;
    }
  }

  public void mouseReleased() {
    locked = false;
  }
}
public int interpolate(PImage img, PVector v) {
  int x1 = floor(v.x);
  int y1 = floor(v.y);
  int x2 = x1 + 1;
  int y2 = y1 + 1;
  float wx1 = x2 - v.x;
  float wy1 = y2 - v.y;

  int c11 = img.get(x1, y1);
  int c12 = img.get(x1, y2);
  int c21 = img.get(x2, y1);
  int c22 = img.get(x2, y2);
  int newcx1 = lerpColor(c12, c11, wy1);
  int newcx2 = lerpColor(c22, c21, wy1);
  int result = lerpColor(newcx2, newcx1, wx1);
  return(result);
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "DistortImage" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
